/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2014 Frederik Heber. All rights reserved.
 *
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Value_atom.cpp
 *
 *  Created on: Sep 11, 2014
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "CodePatterns/MemDebug.hpp"

#include "Value_atom.hpp"

#include "Atom/atom.hpp"
#include "Descriptors/AtomNameDescriptor.hpp"
#include "World.hpp"

template <>
bool Value<const atom *>::isValidAsString(const std::string &_value) const throw(ParameterValidatorException)
{
  return (!const_cast<const World &>(World::getInstance()).getAllAtoms(AtomByName(_value)).empty());
}

template <>
const std::string Value<const atom *>::getAsString() const throw(ParameterValueException)
{
  return get()->getName();
}

template <>
void Value<const atom *>::setAsString(const std::string &_value) throw(ParameterException)
{
  const atom * temp = *(const_cast<const World &>(World::getInstance()).
      getAllAtoms(AtomByName(_value)).begin());
  if (temp != NULL)
    set(temp);
}


